diff --git a/firmware/controllers/algo/event_registry.cpp b/firmware/controllers/algo/event_registry.cpp
index a9af68098db..75573fc7c04 100644
--- a/firmware/controllers/algo/event_registry.cpp
+++ b/firmware/controllers/algo/event_registry.cpp
@@ -26,6 +26,8 @@
 
 InjectionEvent::InjectionEvent() {
 	isSimultanious = false;
+	isOverlapping = false;
+	ownIndex = 0;
 	memset(outputs, 0, sizeof(outputs));
 }
 
diff --git a/firmware/controllers/math/engine_math.cpp b/firmware/controllers/math/engine_math.cpp
index 9bb4f4dc97e..4da85e7c338 100644
--- a/firmware/controllers/math/engine_math.cpp
+++ b/firmware/controllers/math/engine_math.cpp
@@ -101,6 +101,10 @@ void setSingleCoilDwell(engine_configuration_s *engineConfiguration) {
 
 FuelSchedule::FuelSchedule() {
 	clear();
+	for (int cylinderIndex = 0; cylinderIndex < MAX_INJECTION_OUTPUT_COUNT; cylinderIndex++) {
+		InjectionEvent *ev = &elements[cylinderIndex];
+		ev->ownIndex = cylinderIndex;
+	}
 }
 
 void FuelSchedule::clear() {
@@ -217,10 +221,10 @@ bool FuelSchedule::addFuelEventsForCylinder(int i  DECLARE_ENGINE_PARAMETER_SUFF
 void FuelSchedule::addFuelEvents(DECLARE_ENGINE_PARAMETER_SIGNATURE) {
 	clear();
 
-	for (int i = 0; i < CONFIG(specs.cylindersCount); i++) {
-		InjectionEvent *ev = &elements[i];
-		ev->ownIndex = i;
-		bool result = addFuelEventsForCylinder(i PASS_ENGINE_PARAMETER_SUFFIX);
+	for (int cylinderIndex = 0; cylinderIndex < CONFIG(specs.cylindersCount); cylinderIndex++) {
+		InjectionEvent *ev = &elements[cylinderIndex];
+		ev->ownIndex = cylinderIndex;  // todo: is this assignment needed here? we now initialize in constructor
+		bool result = addFuelEventsForCylinder(cylinderIndex PASS_ENGINE_PARAMETER_SUFFIX);
 		if (!result)
 			return;
 	}
